<template>
	<div class="book-details-wrapper">
		<h1>{{ title }}</h1>

		<div class="book-detail">
			<strong>Author:</strong> {{ author }}
		</div>

		<div class="book-detail">
			<strong>Pages:</strong> {{ pages }}
		</div>

		<div class="book-detail">
			<strong>Published:</strong> {{ dateOfPublication }}
		</div>

		<div class="slot-wrapper">
			<slot name="description"></slot>
		</div>

		<div class="likes-container">
			<span class="heart-icon" @click="increaseLikes">💚</span> {{ numberOfLikes }}
		</div>
	</div>
</template>

<script>
	export default {
		name: "BookDetails",
		props: {
			title: String,
			author: String,
			pages: String | Number,
			dateOfPublication: String,
			likes: {
				type: Number,
				default: 10,
				validator: function (value) {
					return value >= 0;
				}
			}
		},
		data: function() {
			return {
				numberOfLikes: this.likes
			}
		},
		methods: {
			increaseLikes: function() {
				this.numberOfLikes++;
			}
		}
	}
</script>

<style scoped>
	.book-details-wrapper {
		position: relative;
		width: 500px;
		height: 500px;
		float: left;
		margin: 20px;
		padding: 20px;
		border-radius: 5px;
		background-color: #dadada;
	}

	.book-detail {
		margin: 10px 0;
	}

	.likes-container {
		position: absolute;
		bottom: 20px;
		right: 20px;
	}

	.heart-icon {
		cursor: pointer;
	}

	ul {
		list-style-type: none;
		padding: 0;
	}

	li {
		display: inline-block;
		margin: 0 10px;
	}

	.slot-wrapper {
		margin-top: 50px;
		text-align: left;
	}
</style>
